package cn.estsh.i3plus.ext.mes.pcn.apiservice.schedulejob;


import cn.estsh.i3plus.ext.mes.pcn.api.base.IMesEquipmentLogService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.util.MesPcnExtConstWords;
import com.alibaba.fastjson.JSONObject;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.quartz.DisallowConcurrentExecution;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;

import java.util.Map;

/**
 * @author wangjie
 * @version 1.0
 * @date 2021/2/2 16:44
 **/
@Slf4j
@DisallowConcurrentExecution
@ApiOperation("保存工艺参数job")
public class MesSaveVariableJob implements Job {

    @Autowired
    private IMesEquipmentLogService mesEquipmentLogService;

    @Override
    public void execute(JobExecutionContext jobExecutionContext) {

        log.info("保存工艺参数job -- START ");

        long startTime = System.currentTimeMillis();

        mesEquipmentLogService.saveEquipmentLogDetails();

        long endTime = System.currentTimeMillis();

        log.info("保存工艺参数job --- END --- 耗时: {} ms", endTime - startTime);

    }
}
